!----------------------------------------------------------
! Anes 20XE :   Anes
!----------------------------------------------------------
!     
!----------------------------------------------------------
! VIA 01.11.12:        STL- 
! VIA 07.09.12:      Anes
! VIA 27.01.11:     set  ANESOS 
! VIA 25.11.10: 
!----------------------------------------------------------
module auTOOLS
 character(265) PathAnes
 character(16) OS
 character(1) DL
 character(256), private:: wStr

!-----------------
!   
!
  integer, parameter :: UF_BIN = 1, UF_TEXT = 2, UF_ERROR = 0
  integer, parameter:: LU_TMP01 = 70, LU_STL = 77

  interface ToStr
    Module procedure IntToStr, Int2ToStr, RealToStr, DoubleToStr, LogToStr
  end interface


!-----------------
!   STL
!
  logical :: IsBIN_OUT = .FALSE.

!---------
contains
!---------

!-------------------------------------------------
!-   GetOS -      
!     iTYPE = 1 : Windows
!           = 2 : Linux
!           = 3 : ......
!    -  SET-:
!  Windows: OS = windows-NT,
!  Linux  : OSTYPE = linux-gnu
!     WINE
!-------------------------------------------------
subroutine GetOS(iTYPE)
  character(32) OOO
!  iTYPE = 1 ! Windows
  call get_environment_variable('ANESOS',OOO)
  call toLOWER(OOO)  
  if(OOO(1:5).EQ.'linux') then
    iTYPE = 2
    return
  endif  
  iTYPE = 1 ! Windows
end subroutine

!-------------------------------------------------
!-      InitUtil
!-------------------------------------------------
subroutine InitUtil
! ---     ---
  call GetOS(iOS)
  if(iOS.EQ.1) OS = 'win'
  if(iOS.EQ.2) OS = 'linux'
  DL ='/'
  if(OS.EQ.'win')  DL='\'
! ---    ANES  ---
  PathAnes = ' ' 
  call get_environment_variable('ANES20XE',PathAnes) 
  if(len_trim(PathAnes).EQ.0) then
    if(OS.EQ.'win') then
      PathAnes = 'c:\anes20xe'
    else
      call get_environment_variable('HOME',PathAnes)
      PathAnes = trim(PathAnes)//'/anes20xe'
    endif
  endif  
end subroutine

!-------------------------------------------------
!-      IsFileExists
!-------------------------------------------------
logical function IsFileExists(nameFile)
 character (*) nameFile
 logical ff
     INQUIRE(FILE=nameFile , EXIST = FF)
     IsFileExists = ff
end function

!-------------------------------------------------
!-      Delete_File
!-------------------------------------------------
subroutine Delete_File(FName)
 CHARACTER(*)   FName
 logical flagFF
!-----
 LU = 98 
 if(FName .EQ. 'con') return
 INQUIRE(FILE=FName , EXIST = flagFF  )
 if(flagFF) then
   OPEN(LU, FILE = FName ,STATUS='old')
   CLOSE(LU ,STATUS='delete')
 end if
end subroutine

!-------------------------------------------------
!-      OpenFile
!-------------------------------------------------
logical function OpenFile(LU,nameFile, flagWrite)
 character (*) nameFile
 logical, optional :: flagWrite
 logical fw, flagFF
!---------
  OpenFile = .TRUE.
!---------
  fw = .FALSE.
  if( present(FlagWrite))  fw = FlagWrite
!-----     ---
  if(FW) THEN
    if(nameFile .NE. 'con') then 
     INQUIRE(FILE=nameFile , EXIST = flagFF  )
     if(flagFF  ) then
             OPEN(LU, FILE = nameFile ,STATUS='old')
             CLOSE( LU ,STATUS='delete')
     end if
    end if
    OPEN(LU, FILE = nameFile ,STATUS='new',ERR=100)
  ELSE
    OPEN(LU, FILE = nameFile ,STATUS='old',ERR=100,ACTION='READ')
  END IF
  Return
!---------
100 CONTINUE
    OpenFile=.FALSE.
end function


!-------------------------------------------------
!-             ToLOWER
!-------------------------------------------------
subroutine ToLOWER(str)
  character (*) str
  integer(4) ch
!------
  le = LEN_TRIM(str)
  if(le .EQ. 0) return
  do i=1,le
     ch = ICHAR(str(i:i))
     if(ch .GE. 65 .AND. ch .LE. 90)  then
                              str(i:i) = CHAR( ch  + 32 )
     else if(ch .GE. 192 .AND. ch .LE. 223)  then
                              str(i:i) = CHAR( ch  + 32 )
     end if
  end do
end SUBROUTINE

!-------------------------------------------------
!-             CHAR2OEM -   Windows
!-------------------------------------------------
character (256) function CHAR2OEM(str)
  character (*) str
!------
  CHAR2OEM = ' '
  DO I = 1,LEN_TRIM(str)
     IC = IACHAR(str(I:I))
     IDif = 0
     if(IC .GE. 192 .AND. IC .LE. 239) IDif = -64
     if(IC .GE. 240 .AND. IC .LE. 255) IDif = -16 
     if (Idif .NE. 0) then
        CHAR2OEM(I:I) = ACHAR(IC+IDif)
     else
        CHAR2OEM(I:I) = str(I:I)
     end if
   END DO
end function

!-------------------------------------------------     
!  Open_Binary_File
!-------------------------------------------------
 logical function Open_Binary_File(LU,nameFile,flagWrite)
 integer LU
 character (*) nameFile
 logical flagWrite
 logical flagFF
!-----------
   Open_Binary_File = .TRUE.
   if(flagWrite) THEN
     INQUIRE(FILE=nameFile , EXIST = flagFF  )
     if(flagFF) then
        OPEN(LU, FILE = nameFile ,STATUS='old')
        CLOSE( LU ,STATUS='delete')
     endif        
   end if
#ifdef _IFOR  
   if(flagWrite) then 
     OPEN(LU, FILE=nameFile ,ERR=100, STATUS='new',FORM='binary')
   else
     OPEN(LU,FILE=nameFile,STATUS='old',FORM='binary',ERR=100)
   endif
#else   
   if(flagWrite) then 
     OPEN(LU, FILE=nameFile ,ERR=100, STATUS='new',FORM='UNFORMATTED', ACCESS='STREAM')
   else
     OPEN(LU, FILE=nameFile ,ERR=100, STATUS='old',FORM='UNFORMATTED', ACCESS='STREAM')
   endif
#endif   
  
   return
100 CONTINUE
   Open_Binary_File  = .FALSE.
end function

!-------------------------------------------------
!     WriteConsole
!-------------------------------------------------
subroutine WriteConsole(Msg)
  character (*) Msg
!----------
  if(OS.EQ.'win') then
    WRITE(*,'(a)')  TRIM(CHAR2OEM(Msg))
  else
    WRITE(*,'(a)')  TRIM(Msg)
  endif  
end subroutine



!*************************************************
!-   STL-
!*************************************************
!-------------------------------------------------     
!  atOpenSaveSTL
!-------------------------------------------------
subroutine atOpenSaveSTL(FName,Title, NoFacet,IsBIN)
 character (*) FName, Title
 logical IsBIN
 integer(4) NoFacet 
 logical flagFF, lRC
!----
  IsBIN_OUT = IsBIN
!----
  INQUIRE(FILE=FName , EXIST = flagFF  )
  if(flagFF) then
    OPEN(LU_STL, FILE = FName ,STATUS='old')
    CLOSE(LU_STL,STATUS='delete')
  end if
!----
  if(IsBIN_OUT) then
  lRC =Open_Binary_File(LU_STL,Fname,.TRUE.)
  else
    OPEN(LU_STL, FILE = FName ,STATUS='new')
  endif  
!----
  LT = Len_Trim(Title)
  if(LT.GT.80) LT = 80
  if(LT.EQ.0)  LT = 1
!----   ----
  if(IsBIN_OUT) then
    do m=1,80
      wStr(m:m) = CHAR(0)
    enddo
    wStr(1:LT) = Title(1:LT)
    write(LU_STL) wStr(1:80)
    write(LU_STL) NoFacet
  else
   write(LU_STL,'(a)') 'solid '//Title(1:LT)  
  endif 
end subroutine 

!-------------------------------------------------     
!  atCloseSaveSTL
!-------------------------------------------------
subroutine atCloseSaveSTL
 if(.not.IsBIN_OUT) then
   write(LU_STL,'(a)') 'endsolid'
 endif
 CLOSE(LU_STL)
end subroutine 

!-------------------------------------------------     
!  atAddFacetSTL
!-------------------------------------------------
subroutine atAddFacetSTL(P1,P2,P3)
 real P1(3),P2(3),P3(3)
 real PN(3),X1(3),X2(3)
 integer(2):: attr = 0
!-----
! 
!-----
   x1=(/(P2(i)-P1(i),i=1,3)/)
   x2=(/(P3(i)-P1(i),i=1,3)/)
   call CrossProduct(x1,x2,PN)
   VV = VecMod(PN)
   PN = PN/(VV+1.e-10)
!-----
   if(IsBIN_OUT) then
     write(LU_STL) PN(1:3), P1(1:3), P2(1:3), P3(1:3), attr
   else
     write(LU_STL,'(a)') 'facet normal '//Trim(RealToStr(PN(1)))//' ' &
                        //Trim(RealToStr(PN(2)))//' '//Trim(RealToStr(PN(3)))
     write(LU_STL,'(a)') 'outer loop'
     write(LU_STL,'(a)') 'vertex '//Trim(RealToStr(P1(1)))//' ' &
                        //Trim(RealToStr(P1(2)))//' '//Trim(RealToStr(P1(3)))
     write(LU_STL,'(a)') 'vertex '//Trim(RealToStr(P2(1)))//' ' &
                        //Trim(RealToStr(P2(2)))//' '//Trim(RealToStr(P2(3)))
     write(LU_STL,'(a)') 'vertex '//Trim(RealToStr(P3(1)))//' ' &
                        //Trim(RealToStr(P3(2)))//' '//Trim(RealToStr(P3(3)))
     write(LU_STL,'(a)') 'endloop'
     write(LU_STL,'(a)') 'endfacet'
   endif
end subroutine

!------------------------------------------------------
!    atAddRectSTL
!------------------------------------------------------
subroutine atAddRectSTL(P1,P2,P3,P4)
 real P1(3), P2(3), P3(3), P4(3)
!-----
  call atAddFacetSTL(P1,P2,P3)
  call atAddFacetSTL(P1,P3,P4)
end subroutine




!-------------------------------------------
!    1  2
!-------------------------------------------
real function DotProduct(x1,x2)
 real x1(3),x2(3)
 DotProduct = 0.0
 do i=1,3
   DotProduct=DotProduct+x1(i)*x2(i)
 enddo
end function

!-------------------------------------------
!    X1  X2
!-------------------------------------------
subroutine CrossProduct(x1,x2,cross)
 real x1(3),x2(3),cross(3)
 Cross = 0.0
 Cross(1) = x1(2)*x2(3)-x1(3)*x2(2)
 Cross(2) = x1(3)*x2(1)-x1(1)*x2(3)
 Cross(3) = x1(1)*x2(2)-x1(2)*x2(1)
end subroutine

!-------------------------------------------
! 2D     X1  X2
!-------------------------------------------
real function CrossProduct2D(x1,x2)
 real x1(2),x2(2)
 CrossProduct2D = x1(1)*x2(2)-x1(2)*x2(1)
end function


!-------------------------------------------
!   
!-------------------------------------------
real function VecMod(x)
 real x(3)
 VecMod = 0.0 
 do i = 1,3
   VecMod=VecMod+x(i)**2
 enddo
 VecMod = sqrt(VecMod)
end function

!-------------------------------------------
!   
!-------------------------------------------
subroutine Vector(V,X,Y,Z)
 real V(3)
 V(1) = X
 V(2) = Y
 V(3) = Z
end subroutine

!-------------------------------------------
!  
!-------------------------------------------
subroutine VecNorm(V)
 real V(3)
 AA = VecMod(V)
 V(1:3) = V(1:3)/(AA+1.e-20)
end subroutine

!-------------------------------------------
!  
!-------------------------------------------
logical function VecEqual(V1,V2)
  real V1(3),V2(3)
  VecEqual = .TRUE.
  do i =1,3
    VecEqual = VecEqual .AND. ABS(V1(I)-V2(I)).LE.1.e-5*(ABS(V1(I))+ABS(V2(I)))
  enddo  
end function



!-------------------------------------------
!   
!-------------------------------------------
real function AreaTri(V1,V2,V3)
 real V1(3),V2(3),V3(3)
 real V21(3),V31(3), AR(3)
 V21 = V2-V1
 V31 = V3-V1
 CALL CrossProduct(V21,V31,AR)
 AreaTri = 0.5 * VecMod(AR)      
end function

!-------------------------------------------
!     ( +  )
!-------------------------------------------
real function VolTriPiramid(Vertex,V1,V2,V3)
 real V1(3),V2(3),V3(3), Vertex(3)
 real V21(3),V31(3), AR(3), H(3)
 V21 = V2-V1
 V31 = V3-V1
 CALL CrossProduct(V21,V31,AR)
 AR = 0.5*AR
 H = V1 - Vertex 
 VolTriPiramid = 1.0/3.0 * DotProduct(AR,H)      
end function

!-------------------------------------------
!   
!-------------------------------------------
real function AreaRect(VN)
 real VN(3,4)
  AreaRect = ABS(AreaTRI(VN(:,1),VN(:,2),VN(:,3))) + ABS(AreaTRI(VN(:,1),VN(:,3),VN(:,4)))
end function


!-------------------------------------------
!      
!-------------------------------------------
real function AreaPolygon(VN,NoPoint,Norm)
 real VN(3,*)
 real Norm(3), cN(3),PC(3), V2(3),V3(3)
 real AreaDIR(3)
!-----
!   -  ,
!   -  
!-----
  Norm = 0.0
  AreaPolygon = 0.0
  R = 0.0
  if(NoPoint.LE.2) return
  if(NoPoint.EQ.3) then
    AreaPolygon = ABS(AreaTRI(VN(:,1),VN(:,2),VN(:,3)))
    call TriangleNormal(VN(:,1),VN(:,2),VN(:,3),Norm)
    return
  endif 
  AreaDIR = 0.0
!  AreaPoligon = 0.0
  do iTRI =1,NoPoint-2
    AreaZZ = ABS(AreaTRI(VN(:,1),VN(:,iTRI+1),VN(:,iTRI+2)))
    call TriangleNormal(VN(:,1),VN(:,iTRI+1),VN(:,iTRI+2),cN)
    do m=1,3
        AreaDIR(m) = AreaDIR(m) + AreaZZ*cN(m)
    enddo    
!    AreaDIR = AreaDIR + AreaZZ*cN
!    AreaPoligon =  AreaPoligon + AreaZZ
  enddo  
  AreaPolygon =  SQRT(AreaDIR(1)**2 + AreaDIR(2)**2 + AreaDIR(3)**2)
  Norm(1:3) = AreaDIR(1:3)/AreaPolygon
end function


!-------------------------------------------
!        iDIR
!-------------------------------------------
real function DirAreaPolygon(iDir,VN,NoPoint)
 real VN(3,*)
 real Norm(3), cN(3),V2(3),V3(3)
!-----
!   -  ,
!   -  
!-----
  DirAreaPolygon = 0.0
  if(NoPoint.LE.2) return
!-----
!VIA 07.10.10:      
!-----
  do iTRI =1,NoPoint-2
    AreaZZZ = ABS(AreaTRI(VN(:,1),VN(:,iTRI+1),VN(:,iTRI+2)))
    call TriangleNormal(VN(:,1),VN(:,iTRI+1),VN(:,iTRI+2),cN)
    DirAreaPolygon = DirAreaPolygon + AreaZZZ * cN(iDir)
  enddo 
end function




!-------------------------------------------
!    
!-------------------------------------------
subroutine TriangleNormal(V1,V2,V3,Norm)
 real V1(3), V2(3), V3(3), X1(3),X2(3)
 real Norm(3)
!-----
!       
!-----
  x1 = V2 - V1
  x2 = V3 - V1
  call CrossProduct(x1,x2,NORM)
  call VecNorm(NORM)
end subroutine




!------------------------------------------------
!-      
!------------------------------------------------
character(16) function IntToStr(I)
  integer I  
  write(IntToStr,'(i13)') I
  IntToStr = ADJUSTL(IntToStr)
end function

character(16) function Int2ToStr(I)
  integer(2) I  
  write(Int2ToStr,'(i7)') I
  Int2ToStr = ADJUSTL(Int2ToStr)
end function

character(16) function RealToStr(R)
   real(4) R
    write(RealToStr,'(1Pg13.6)') R
    RealToStr = ADJUSTL(RealToStr)
end function

character(16) function DoubleToStr(R)
   real(8) R
    write(DoubleToStr,'(1Pg16.8)') R
    DoubleToStr = ADJUSTL(DoubleToStr)
end function


character(16) function LogToStr(L)
logical L
    write(LogToStr,'(l7)') L
    LogToStr = ADJUSTL(LogToStr)
end function




end MODULE